/*
 * control_center_downstream.h
 *
 *  Created on: 05.06.2018
 *      Author: Constantin
 */

#ifndef INC_CONTROL_CENTER_DOWNSTREAM_H_
#define INC_CONTROL_CENTER_DOWNSTREAM_H_

#include "af3.h"
#define INTBASE 10  //!< Base for conversion from string to int (10 for dec)

/** REMOVE THIS THIS IS DUMMY CODE
#define STRING_MAX_LEN 100
// new structure for receiveing message
typedef struct receive_message_t{
	char modulename[STRING_MAX_LEN];
	char variablename[STRING_MAX_LEN];
	char value[STRING_MAX_LEN];
	char time[STRING_MAX_LEN];
}receive_message_t;
*/

//void af3_cc_listen(void (*somefunctionpointer)(receive_message_t));
//end dummy code section

/**
 * \brief Initialize the downstream communication for control center.
 * Currently just initializes a mutex and starts a thread listening for incoming
 * messages.
 */
void af3_cc_donwstream_init(void);

/**
 * \brief Handler function for received control center downstream messages.
 * Stores a given received message in a list of received messages for further
 * processing.
 * @param received_message The received message to be handled.
 */
void cc_downstream_message_handler(receive_message_t received_message);

/**
 * \brief Get a received integer variable with the given name.
 * Checks whether an integer variable with the given name was received. If so
 * the value of the received variable is converted to integer an stored at the
 * given destination. If no appropriate message was received the destination
 * variable won't get modified.
 * @param userfriendly_name The userfriendly name of the variable to search for.
 * @param variable_to_write A pointer to the destination where the integer value
 * will be stored if a message was received containing the desired variable.
 * @return Positive if the destination variable was updated, negative otherwise.
 */
int af3_cc_get_int(char* userfriendly_name, GEN_TYPE_int* variable_to_write);

/**
 * \brief Get a received boolean variable with the given name.
 * Checks whether an boolean variable with the given name was received. If so
 * the value of the received variable is converted to boolean an stored at the
 * given destination. If no appropriate message was received the destination
 * variable won't get modified.
 * @param userfriendly_name The userfriendly name of the variable to search for.
 * @param variable_to_write A pointer to the destination where the boolean value
 * will be stored if a message was received containing the desired variable.
 * @return Positive if the destination variable was updated, negative otherwise.
 */
int af3_cc_get_bool(char* userfriendly_name,
		GEN_TYPE_boolean* variable_to_write);

/**
 * \brief Get a received double variable with the given name.
 * Checks whether an double variable with the given name was received. If so
 * the value of the received variable is converted to double an stored at the
 * given destination. If no appropriate message was received the destination
 * variable won't get modified.
 * @param userfriendly_name The userfriendly name of the variable to search for.
 * @param variable_to_write A pointer to the destination where the double value
 * will be stored if a message was received containing the desired variable.
 * @return Positive if the destination variable was updated, negative otherwise.
 */
int af3_cc_get_double(char* userfriendly_name,
		GEN_TYPE_double* variable_to_write);



#endif /* INC_CONTROL_CENTER_DOWNSTREAM_H_ */
